import java.io.*;

public class Main {
    static public void main( String []args ) {

    Main c = new Main();
    
    char []array = c.readFile( "array-1.g" );
    c.createArrays( array, "$Array$1$_char", "_char", "_Char", "char" );
    c.createArrays( array, "$Array$1$_boolean", "_boolean", "_Boolean", "boolean" );
    c.createArrays( array, "$Array$1$_byte", "_byte", "_Byte", "byte" );
    c.createArrays( array, "$Array$1$_integer", "_integer", "_Integer", "int" );
    c.createArrays( array, "$Array$1$_long", "_long", "_Long", "long" );
    c.createArrays( array, "$Array$1$_real", "_real", "_Real", "float" );
    c.createArrays( array, "$Array$1$_double", "_double", "_Double", "double" );
    
    array = c.readFile( "array-2.g" );
    c.createArrays( array, "$Array$2$_char", "_char", "_Char", "char" );
    c.createArrays( array, "$Array$2$_boolean", "_boolean", "_Boolean", "boolean" );
    c.createArrays( array, "$Array$2$_byte", "_byte", "_Byte", "byte" );
    c.createArrays( array, "$Array$2$_integer", "_integer", "_Integer", "int" );
    c.createArrays( array, "$Array$2$_long", "_long", "_Long", "long" );
    c.createArrays( array, "$Array$2$_real", "_real", "_Real", "float" );
    c.createArrays( array, "$Array$2$_double", "_double", "_Double", "double" );
    
    // not used : @ is the array class name
    // ^ is the type of the array elements in Green
    // not used : # is the wrapper class name associated to ^ in Green
    // ? is the java name for the array element type

    array = c.readFile( "iter-1.g" );
    c.createArrays( array, "$Iter$Array$1$_char", "_char", "_Char", "char" );
    c.createArrays( array, "$Iter$Array$1$_boolean", "_boolean", "_Boolean", "boolean" );
    c.createArrays( array, "$Iter$Array$1$_byte", "_byte", "_Byte", "byte" );
    c.createArrays( array, "$Iter$Array$1$_integer", "_integer", "_Integer", "int" );
    c.createArrays( array, "$Iter$Array$1$_long", "_long", "_Long", "long" );
    c.createArrays( array, "$Iter$Array$1$_real", "_real", "_Real", "float" );
    c.createArrays( array, "$Iter$Array$1$_double", "_double", "_Double", "double" );
    

    array = c.readFile( "iter-2.g" );
    c.createArrays( array, "$Iter$Array$2$_char", "_char", "_Char", "char" );
    c.createArrays( array, "$Iter$Array$2$_boolean", "_boolean", "_Boolean", "boolean" );
    c.createArrays( array, "$Iter$Array$2$_byte", "_byte", "_Byte", "byte" );
    c.createArrays( array, "$Iter$Array$2$_integer", "_integer", "_Integer", "int" );
    c.createArrays( array, "$Iter$Array$2$_long", "_long", "_Long", "long" );
    c.createArrays( array, "$Iter$Array$2$_real", "_real", "_Real", "float" );
    c.createArrays( array, "$Iter$Array$2$_double", "_double", "_Double", "double" );
    

    }

    void createArrays( 
       char []array,
       String arrayClassName, 
       String arrayElementType,
       String wrapperType,
       String javaElementType
       ) {

       PrintWriter out;
       try { 
          out = 
             new PrintWriter( new FileOutputStream( arrayClassName + ".g" ) ) ;
       } catch ( Exception e ) {
           show("File " + arrayClassName + ".g cannot be created" );
           return;
       }

       for (int j = 0; j < array.length; j++)
         switch ( array[j] ) {
            case ch_arrayClassName :
               out.print( arrayClassName );
               break;
            case ch_arrayElementType :
               out.print( arrayElementType );
               break;
            case ch_wrapperType :
               out.print( wrapperType );
               break;
            case ch_javaElementType :
               out.print( javaElementType );
               break;
            default :
               out.print(array[j]);
         }
       out.close();
       }

    final char ch_arrayClassName = '@';
    final char ch_arrayElementType = '^';
    final char ch_wrapperType = '#';
    final char ch_methodName = '%';
    final char ch_javaElementType = '?';
    
       
// @ is the array class name
// ^ is the type of the array elements
// # is the wrapper class name associated to ^ in Green
// % is the method name of # that retrieves the value stored in the wrapper object
    
        
    private char []readFile( String fileName ) {
        FileReader stream;
        int numChRead;
        
        File file = new File(fileName);
        if ( ! file.exists() || ! file.canRead() ) {
           show("Either the file " + fileName + " does not exist or it cannot be read");
           return null;
         }
         try { 
             stream = new FileReader(file);  
         } catch ( FileNotFoundException e ) {
            show("Something wrong: file " + fileName + " does not exist anymore");
            return null;
         }
                // one more character for '\0' at the end that will be added by the
                // compiler
         char []input = new char[ (int ) file.length() + 1 ];
            
         try {
            numChRead = stream.read( input, 0, (int ) file.length() );
         } catch ( IOException e ) {
            show("Error reading file " + fileName);
            return null;
         }
                
         if ( numChRead != file.length() ) {
            show("Read error in file " + fileName);
            return null;
         }
         try {
            stream.close();
         } catch ( IOException e ) {
            show("Error in handling the file " + fileName );
            return null;
         }
         return input;
    }
    
    private void show( String msg ) {
        System.out.println(msg);
        System.exit(0);
    }
    
}
           
           
           
        