// @ is the array class name
// ^ is the type of the array elements in Green
// # is the wrapper class name associated to ^ in Green
// ? is the java name for the array element type


class @ subclassOf AnyArray
      proc init( size : integer ) 
         begin
         java$begin
         v = new ?[size = _size];
         java$end
         end
   public:
      proc getSize() : integer
         begin
         java$begin
         return size;
         java$end
         end
      proc toString() : String
         begin
         java$begin
         StringBuffer s = new StringBuffer("{ ");
         int n = size - 1;
         int i = 0;
         while ( i < size ) {
                // _byte._toString(v[i]);
             s.append( __^._toString(v[i]) ) ;
             if ( i < n ) 
                 s.append(", ");
             i++;
         }
         s.append(" }");
         return s.toString();
         java$end
         end
         
      proc get( i : integer ) 
              (exception : CatchAnyArrayException) : Any
         begin
         java$begin
         if ( _i >= size || _i < 0 )
            throw new PackedException( _IllegalArrayIndexException.$classObject._new$int$_AnyArray(_i, this) );
         else
            return #.$classObject._new$?(v[_i]);
         java$end
         end
         
      proc set( value : Any; i : integer )
              (exception : CatchAnyArrayException)
          begin
          java$begin
          if ( _i >= size || _i < 0 )
             throw new PackedException( _IllegalArrayIndexException.$classObject._new$int$_AnyArray(_i, this) );
          try { 
              v[_i] = ((# ) _value)._get();
          } catch ( Exception e ) {
              throw new PackedException( _TypeErrorException.$classObject._new() );
          }
          java$end
          end
          
       proc getIter() : Iter(^)
          begin
          java$begin
          return _BasicIter$?.$classObject._new$$Array$1$?(this);
          java$end
          end
          
       proc forEach( f : Function(^) ) 
          begin
          java$begin
          for(int i = 0; i < size; i++)
             (($pc$Function$1$? ) _f)._exec$?(v[i]);  //_exec$_ConstantInfo
          java$end
          end
          
       proc replaceBy( cmd : Command(^) ) 
          begin
          java$begin
          for (int i = 0; i < size; i++)
             v[i] = (($pc$Command$1$? ) _cmd)._doIt$?(v[i]);
          java$end
          end
          
       proc collect( f : Filter(^) )
                   ( exception : TypeErrorException ) : @
          begin
          java$begin
          boolean indexArray[] = new boolean[size];
          int i, n;
          n = 0;
          for (i = 0; i < size; i++) {
            indexArray[i] = (($pc$Filter$1$? ) _f)._test$?(v[i]);
            if ( indexArray[i] ) 
               n++;
          }
          @ newArray = (@ ) @.$classObject._new$int(n);
          int j = 0;
          for (i = 0; i < size; i++) {
             if ( indexArray[i] ) {
                 newArray.v[j] = v[i];
                 j++;
             }
          }
          return newArray;
          java$end
          end

          
          
       proc remove( f : Filter(^) )
          begin
          java$begin
          boolean indexArray[] = new boolean[size];
          int i, n;
          n = 0;
          for (i = 0; i < size; i++) {  
            indexArray[i] = ! (($pc$Filter$1$? ) _f)._test$?(v[i]);;
            if ( indexArray[i] ) 
               n++;
          }
          ? []newArray = new ?[n];
          int j = 0;
          for (i = 0; i < size; i++) {
             if ( indexArray[i] ) {
                 newArray[j] = v[i];
                 j++;
             }
          }
          v = newArray;
          size = n;
          java$end
          end
          
          
       proc reset()
          begin
          java$begin
          index = 0;
          java$end
          end
          
       proc more() : boolean
          begin
          java$begin
          return index < size;
          java$end
          end
          
       proc next() : ^
          begin
          java$begin
          ? elem;
          if ( index < size ) 
             elem = v[index];
          else
            throw new PackedException( _IllegalArrayIndexException.$classObject._new$int$_AnyArray(index, this) );
          index++;
          return elem;
          java$end
          end
          
   java$begin
   
   public $Array$1$?( ? []anArray ) {
      v = anArray;
      size = anArray.length;
   }
   
   public ? []v;
   public int size, index;
   java$end
end
