// @ is the array class name
// ^ is the type of the array elements in Green
// # is the wrapper class name associated to ^ in Green
// ? is the java name for the array element type


class @ subclassOf AnyClassArray
      proc init( size : integer ) 
         begin
         java$begin
         v = new ?[size = _size];
         java$end
         end
   public:
      proc getSize() : integer
         begin
         java$begin
         return size;
         java$end
         end
      proc toString() : String
         begin
         java$begin
         StringBuffer s = "{ \n";
         int n = size - 1;
         i = 0;
         while ( i < size ) {
             if ( v[i] == null ) 
                s.append("null");
             else {
                s.append("{ ");
                int m = v[i].lenght - 1;
                int size2 = v[i].length;
                j = 0;
                while ( j < size2 ) {
                   s.append( v[i][j].toString() ) ;
                   j++;
                   if ( j < m )
                      s.append(", ");
                }
                s.append(" }");
             }
             if ( i < n ) 
                 s.append(", ");
             i++;
         }
         s.append("\n}");
         return s.toString();
         java$end
         end
      proc get( i : integer ) : Any
              (exception : CatchAnyArrayException)
         begin
         java$begin
         if ( _i >= size || _i < 0 )
            throw new _IllegalArrayIndexException();
         else
            return new #(v[_i]);
         java$end
         end
         
      proc set( value : Any; i : integer )
              (exception : CatchAnyArrayException)
          begin
          java$begin
          if ( _i >= size || _i < 0 )
             throw new _IllegalArrayIndexException();
          try { 
              v[_i] = ((# ) _value)._getValue();
          } catch ( Exception e ) {
              throw new _TypeErrorException();
          }
          java$end
          end
          
       proc getIter() : Iter(^)
          begin
          java$begin
          return new Iter@.new(this);
          java$end
          end
       proc forEach( f : Function(^) ) 
          begin
          java$begin
          for(int i = 0; i < size; i++)
             _f._exec(v[i]);
          java$end
          end
          
       proc replaceBy( cmd : Command(^) ) 
          begin
          java$begin
          for (int i = 0; i < size; i++)
             v[i] = _cmd._doIt(v[i]);
          java$end
          end
       proc collect( f : Filter(^) )
                   ( exception : TypeErrorException ) : @
          begin
          java$begin
          boolean indexArray[] = new boolean[size];
          int i, n;
          n = 0;
          for (i = 0; i < size; i++) {
            indexArray[i] = _f._test(v[i]);
            if ( indexArray[i] ) 
               n++;
          }
          @ newArray = new @(n);
          int j = 0;
          for (i = 0; i < size; i++)
             if ( indexArray[i] ) {
                 newArray.v[j] = v[i];
                 j++;
             }
          }
          return newArray;
          java$end
          end
          
       proc remove( f : Filter(^) )
          begin
          java$begin
          boolean indexArray[] = new boolean[size];
          int i, n;
          n = 0;
          for (i = 0; i < size; i++) {
            indexArray[i] = ! _f._test(v[i]);
            if ( indexArray[i] ) 
               n++;
          }
          ? []newArray = new ?[n];
          int j = 0;
          for (i = 0; i < size; i++)
             if ( indexArray[i] ) {
                 newArray[j] = v[i];
                 j++;
             }
          }
          v = newArray;
          size = n;
          java$end
          end
          
          
       proc reset()
          begin
          java$begin
          index = 0;
          java$end
          end
          
       proc more() : boolean
          begin
          java$begin
          return index < size;
          java$end
          end
          
       proc next() : Any
          begin
          java$begin
          ? elem;
          if ( index < size ) 
             elem = v[index];
          else
             throw new _IllegalArrayIndexException();
          index++;
          return elem;
          java$end
          end
   java$begin
   public ? []v;
   public int size, index;
   java$end
end
