object byte

  public:
  
    proc getSizeInBits() : integer
       // returns the size of a byte in bits 
       begin
       return 8;
       end
       
    proc getSize() : integer
       // return the size of a byte variable in bytes 
       begin
       return 1;
       end
      
    proc cast( any : AnyClass )
             ( exception : TypeErrorException ) : byte 
      begin
      java$begin
      if ( _any instanceof _Boolean )
         return (byte ) (((_Boolean ) _any)._get() ? 1 : 0);
      else if ( _any instanceof _Byte ) 
         return ((_Byte ) _any)._get();
      else if ( _any instanceof _Integer ) 
         return (byte ) ((_Integer ) _any)._get();
      else 
         throw new PackedException(_TypeErrorException.$classObject._new());
      java$end
      end

    proc cast( value : boolean ) : byte
       begin
       java$begin
       return (byte ) (_value ? 1 : 0);
       java$end
       end
      
    proc cast( value : char ) : byte
       begin
       java$begin
       return (byte ) _value;
       java$end
       end
      

    proc cast( value : integer ) : byte
          assert
             before castOk(value);
          end
       begin
       java$begin
       return (byte ) _value;
       java$end
       end
      
    proc cast( value : long ) : byte
          assert
             before castOk(value);
          end
       begin
       java$begin
       return (byte ) _value;
       java$end
       end
      
    proc cast( value : real ) : byte
          assert
             before castOk(value);
          end
       begin
       java$begin
       return (byte ) _value;
       java$end
       end
      
    proc cast( value : double ) : byte
          assert
             before castOk(value);
          end
       begin
       java$begin
       return (byte ) _value;
       java$end
       end
       
    proc castOk( any : AnyClass ) : boolean
      begin
      var aClass : Any = any.getClassObject();
      return aClass == Boolean or aClass == Byte or  
             aClass == Integer;
      end

    proc castOk( value : integer ) : boolean
      begin
      java$begin
      // return value >= byte.getMinValue() and 
      //       value <= byte.getMaxValue();
      return _value >= -128 && _value <= 127;
      java$end
      end      
            
    proc castOk( value : long ) : boolean
      begin
      java$begin
      // return value >= byte.getMinValue() and 
      //       value <= byte.getMaxValue();
      return _value >= -128 && _value <= 127;
      java$end
      end      
            
    proc castOk( value : real ) : boolean
      begin
      java$begin
      /*
      return value >= byte.getMinValue() and 
             value <= byte.getMaxValue();
      */
      return _value >= -128 && _value <= 127;
      java$end
      end      
            
    proc castOk( value : double ) : boolean
      begin
      java$begin
      /*
      return value >= byte.getMinValue() and 
             value <= byte.getMaxValue();
      */
      return _value >= -128 && _value <= 127;
      java$end
      end      
            
    proc getMinValue() : byte
      begin
      return -127b - 1b;
      end
    proc getMaxValue() : byte
      begin
      return 127b;
      end
      
end


class byte subclassOf AnyValue
  public:
  
    proc getInfo() : AnyObjectInfo
       begin
       return nil;
       end
    
  
    proc toString() : String 
       begin
       java$begin
       return (new Byte(_self)).toString();
       java$end
       end
    proc equals( other : byte ) : boolean
       // returns true if self is equal to other 
       begin
       java$begin
       return _self == _other;
       java$end
       end
    
      /* these operators can only be used with variables. Unlike C++, they
        don't return anything. */
    proc ++()
    proc --()
    
      // unary 
    proc +  () : byte    
    proc -  () : byte    
    proc ~  () : byte    
      // binary 
    proc +  ( other : byte ) : byte    
    proc -  ( other : byte ) : byte    
    proc *  ( other : byte ) : byte    
    proc /  ( other : byte ) : byte    
    proc %  ( other : byte ) : byte    
    proc &  ( other : byte ) : byte    
    proc |  ( other : byte ) : byte    
    proc ^  ( other : byte ) : byte    
    proc << ( other : integer ) : byte    
    proc >> ( other : integer ) : byte    
    
      // comparison 
    proc == ( other : byte ) : boolean    
    proc <> ( other : byte ) : boolean    
    proc <  ( other : byte ) : boolean    
    proc <= ( other : byte ) : boolean    
    proc >  ( other : byte ) : boolean    
    proc >= ( other : byte ) : boolean    
    
  //private:
  //  var value : lowLevelByte;
end

