object double

  public:
  
    proc getSizeInBits() : integer
       // returns the size of a double in bits
       begin
       return 64;
       end
       
    proc getSize() : integer
       // return the size of a double variable in bytes
       begin
       return 8;
       end
      
    proc cast( any : AnyClass )
             ( exception : TypeErrorException ) : double 
      begin
      var aClass : Any = any.getClassObject();
      if aClass == Byte 
      then
         return Byte.cast(any).getValue();
      else
         if aClass == Integer 
         then
            return Integer.cast(any).getValue();
         else
            if aClass == Long 
            then
               return Long.cast(any).getValue();
            else
               if aClass == Real 
               then
                  return Real.cast(any).getValue();
               else
                  if aClass == Double
                  then
                     return Double.cast(any).getValue();
                  else
                     exception.throw( TypeErrorException.new() );
                  endif
               endif
            endif
         endif
      endif
      end
      
    proc cast( value : byte ) : double
       begin
       java$begin
       return (double ) _value;
       java$end
       end
       
    proc cast( value : integer ) : double
       begin
       // return value;
       java$begin
       return (double ) _value;
       java$end
       end
       
    proc cast( value : long ) : double
       begin
       //return value;
       java$begin
       return (double ) _value;
       java$end
       end
       
    proc cast( value : real ) : double
       begin
       //return value;
       java$begin
       return (double ) _value;
       java$end
       end
       
    
    proc castOk( any : AnyClass ) : double
      begin
      var aClass : Any = any.getClassObject();
      return aClass == Byte or aClass == Integer or aClass == Long or
             aClass == Real or aClass == Double;
      end
      
      /* each of the following methods is based on a similar constant
         found in the header file "limits.h" of the standard C
         library. The method description is a  copy of the
         description of the corresponding constant as found in K&R. The
         method bodies are dependent on the platform and therefore not
         defined. */
        
    proc getRadix() : integer
       // radix of exponent representation 
       begin
       return 0;
       end
       
    proc getRounds() : integer
       // mode for addition
       begin
       return 0;
       end
       
    proc getPrecision() : integer
       // decimal digits of precision
       begin
       return 0;
       end
       
    proc getEpsilon() : real
       // smaller number e such that 1.0 + e <> 1.0
       begin
       return 0.0;
       end
       
    proc getMantDig() : integer
       // number of base ``getRadix()'' in mantissa
       begin
       return 0;
       end
       
    proc getMinValue() : real
       // minimum real number
       begin
       return 0.0;
       end
       
    proc getMaxValue() : real
       // maximum real number
       begin
       return 0.0;
       end
       
    proc getMaxExp() : real 
       // greater k such that k^n is representable
       begin
       return 0.0;
       end
       
      
    proc getMinExp() : real
       // smaller k such that k^n is a normalized number
       begin
       return 0.0;
       end
       
end


class double subclassOf AnyValue
  public:
    proc toString() : String
       begin
       end
    proc equals( other : double ) : boolean
         /* returns true if self is equal to other. A warning should be
            issued if this method is used */
       begin
       end
    
      /* these operators can only be used with variables. Unlike C++, they
        don't return anything. */
    proc ++()
    proc --()
    
      // unary 
    proc +  () : double    
    proc -  () : double    
      /* binary */
    proc +  ( other : double ) : double    
    proc -  ( other : double ) : double    
    proc *  ( other : double ) : double    
    proc /  ( other : double ) : double    
    
      // comparison. A warning should be issued whenever == or <> is used. 
    proc == ( other : double ) : boolean    
    proc <> ( other : double ) : boolean    
    proc <  ( other : double ) : boolean    
    proc <= ( other : double ) : boolean    
    proc >  ( other : double ) : boolean    
    proc >= ( other : double ) : boolean    

  //private:
  //  var value : lowLevelDouble;
end

   
