object integer

  public:
  
    proc getSizeInBits() : integer
         // returns the size of an integer in bits 
       begin
       return 32;
       end
       
    proc getSize() : integer
       // return the size of an integer variable in bytes 
       begin
       return 4;
       end
      
    proc cast( any : AnyClass )
             ( exception : CatchTypeErrorException ) : integer 
      begin
      var aClass : Any = any.getClassObject();
      if aClass == Char 
      then
         return Char.cast(any).getValue();
      else 
         if aClass == Boolean 
         then
            return Boolean.cast(any).getValue();
         else
            if aClass == Byte 
            then
               return Byte.cast(any).getValue();
            else
               if aClass == Integer 
               then
                  return Integer.cast(any).getValue();
               else
                  if aClass == Long 
                  then
                     return Long.cast(any).getValue();
                  else
                     if aClass == Real 
                     then
                        return Real.cast(any).getValue();
                     else
                        if aClass == Double
                        then
                           return Double.cast(any).getValue();
                        else 
                           exception.throw( TypeErrorException.new() );
                        endif
                     endif
                  endif
               endif
            endif
         endif
      endif
      end
      
    proc cast( value : char ) : integer
       begin
       java$begin
       return (int ) _value;
       java$end
       end
       
    proc cast( value : boolean ) : integer
       begin
       java$begin
       return (int ) _value;
       java$end
       end
       
    proc cast( value : byte ) : integer
       begin
       java$begin
       return (int ) _value;
       java$end
       end
       
    proc cast( value : long ) : integer
         assert 
           before castOk(value);
         end
       begin
       java$begin
       return (int ) _value;
       java$end
       end
      
    proc cast( value : real ) : integer
         assert 
           before castOk(value);
         end
       begin
       java$begin
       return (int ) _value;
       java$end
       end
       
    proc cast( value : double ) : integer
         assert 
           before castOk(value);
         end
       begin
       java$begin
       return (int ) _value;
       java$end
       end
      
    proc castOk( any : AnyClass ) : integer
      begin
      var aClass : Any = any.getClassObject();
      return aClass == Char or aClass == Boolean or aClass == Byte or
             aClass == Integer or aClass == Long or 
             aClass == Real or aClass == Double;
      end
      
    proc castOk( value : double ) : boolean
      begin
      return value >= integer.getMinValue() and
             value <= integer.getMaxValue();
      end

    proc castOk( value : real ) : boolean
      begin
      return value >= integer.getMinValue() and
             value <= integer.getMaxValue();
      end
      
    proc castOk( value : long ) : boolean
      begin
      return value >= integer.getMinValue() and
             value <= integer.getMaxValue();
      end
  
    proc getMinValue() : integer
      begin
      return -2147483647 - 1;
      end
    proc getMaxValue() : integer
      begin
      return 2147483647;
      end    
end


class integer subclassOf AnyValue
  public:
    proc toString() : String
       begin
       end
    proc equals( other : integer ) : boolean
      // returns true if self is equal to other 
      begin
      end
        
    
      /* these operators can only be used with variables. Unlike C++, they
        don't return anything. */
    proc ++()
    proc --()
    
      // unary
    proc +  () : integer    
    proc -  () : integer    
    proc ~  () : integer    
      // binary 
    proc +  ( other : integer ) : integer    
    proc -  ( other : integer ) : integer    
    proc *  ( other : integer ) : integer    
    proc /  ( other : integer ) : integer    
    proc %  ( other : integer ) : integer    
    proc &  ( other : integer ) : integer    
    proc |  ( other : integer ) : integer    
    proc ^  ( other : integer ) : integer    
    proc << ( other : integer ) : integer    
    proc >> ( other : integer ) : integer    
    
      // comparison
    proc == ( other : integer ) : boolean    
    proc <> ( other : integer ) : boolean    
    proc <  ( other : integer ) : boolean    
    proc <= ( other : integer ) : boolean    
    proc >  ( other : integer ) : boolean    
    proc >= ( other : integer ) : boolean    

     /* in the method that follow we assume an integer has at least
       four bytes */
    proc getByte1() : byte
      /* returns the value of the less significant byte of the integer. In some
         machines this will be the first byte. In others, it will be 
         the last. The following methods work similarly. */
       begin
       return 0;
       end
    proc getByte2() : byte
       begin
       return 0;
       end
    proc getByte3() : byte
       begin
       return 0;
       end
    proc getByte4() : byte
       begin
       return 0;
       end
      
  //private:
  //  var value : lowLevelInteger;
    
end

