object long

  public:  
  
    proc getSizeInBits() : integer
       // returns the size of a long in bits 
       begin
       return 64;
       end
      
    proc getSize() : integer
       // return the size of a long variable in bytes 
       begin
       return 8;
       end
      
    proc cast( any : AnyClass )
             ( exception : TypeErrorException ) : long 
      begin
      var aClass : Any = any.getClassObject();
      if aClass == Long 
      then
         return Long.cast(any).get();
      else 
         if aClass == Integer 
         then
            return Long.cast(Integer.cast(any).get());
         else
            if aClass == Byte
            then
               return Long.cast(Byte.cast(any).get());
            else
               if aClass == Real 
               then
                  return Long.cast(Real.cast(any).get());
               else
                  if aClass == Double
                  then
                     return Long.cast(Double.cast(any).get());
                  else
                     exception.throw( TypeErrorException.new() );
                  endif
               endif
            endif
         endif
      endif
      end
      
    proc cast( value : byte ) : long
       begin
       java$begin
       return (long ) _value;
       java$end
       end
       
    proc cast( value : integer ) : long
       begin
       java$begin
       return (long ) _value;
       java$end
       end
       
    proc cast( value : real ) : long
          assert
             before castOk(value);
          end  
       begin
       java$begin
       return (long ) _value;
       java$end
       end
       
    proc cast( value : double ) : long
          assert
             before castOk(value);
          end  
       begin
       java$begin
       return (long ) _value;
       java$end
       end
       
      
    proc castOk( any : AnyClass ) : boolean
      begin
      var aClass : Any = any.getClassObject();
      return aClass == Long or aClass == Integer or aClass == Byte or
             aClass == Real or aClass == Double;
      end
      
    proc castOk( value : double ) : boolean
      begin
      return value >= long.getMinValue() and
             value <= long.getMaxValue();
      end

    proc castOk( value : real ) : boolean
      begin
      return value >= long.getMinValue() and
             value <= long.getMaxValue();
      end
      
    proc getMinValue() : long
      begin
      return -2147483647*2147483647 - 1;
      end
      
    proc getMaxValue() : long
      begin
      return 2147483647*2147483647;
      end    
      
end


class long subclassOf AnyValue
  public:
    proc toString() : String
       begin
       end
    proc equals( other : long ) : boolean
       begin
       end
      // returns true if self is equal to other 
    
      /* these operators can only be used with variables. Unlike C++, they
         don't return anything. */
    proc ++()
    proc --()
    
      // unary 
    proc +  () : long    
    proc -  () : long    
    proc ~  () : long    
      // binary 
    proc +  ( other : long ) : long    
    proc -  ( other : long ) : long    
    proc *  ( other : long ) : long    
    proc /  ( other : long ) : long    
    proc %  ( other : long ) : long    
    proc &  ( other : long ) : long    
    proc |  ( other : long ) : long    
    proc ^  ( other : long ) : long    
    proc << ( other : integer ) : long    
    proc >> ( other : integer ) : long    
    
      // comparison 
    proc == ( other : long ) : boolean    
    proc <> ( other : long ) : boolean    
    proc <  ( other : long ) : boolean    
    proc <= ( other : long ) : boolean    
    proc >  ( other : long ) : boolean    
    proc >= ( other : long ) : boolean    
    
     /* in the method that follow we assume a long has at least
        eight bytes */
    proc getByte1() : byte
       /* returns the value of the less significant byte of the long. In some
          machines this will be the first byte. In others, it will be 
          the last. The methods getByte2, getByte3, ... getByte8 work similarly. */
       begin
       end

      
  //private:
  //  var value : lowLevelLong;
end

