object real

  public:
  
    proc getSizeInBits() : integer
       // returns the size of a real in bits 
       begin
       return 32;
       end
    proc getSize() : integer
        // return the size of a real variable in bytes 
       begin
       return 4;
       end
      
    proc cast( any : AnyClass )
             ( exception : TypeErrorException ) : real 
      begin
      java$begin
      if ( _any instanceof _Byte )
         return (float ) ((_Byte ) _any)._get();
      else if ( _any instanceof _Integer )
         return (float ) ((_Integer ) _any)._get();
      else if ( _any instanceof _Long )
         return (float ) ((_Long ) _any)._get();
      else if ( _any instanceof _Real )
         return (float ) ((_Real ) _any)._get();
      else if ( _any instanceof _Double )
         return (float ) ((_Double ) _any)._get();
      else
         throw new PackedException(_TypeErrorException.$classObject._new());
         
      java$end
      end
      
    proc cast( value : byte ) : real
       begin
       java$begin
       return (float ) _value;
       java$end
       end
       
    proc cast( value : integer ) : real
       begin
       java$begin
       return (float ) _value;
       java$end
       end
       
    proc cast( value : long ) : real
       begin
       java$begin
       return (float ) _value;
       java$end
       end
       
    proc cast( value : double ) : real
          assert
             before castOk(value);
          end  
       begin
       java$begin
       return (float ) _value;
       java$end
       end
       
      
    proc castOk( any : AnyClass ) : boolean
      begin
      var aClass : Any = any.getClassObject();
      return aClass == Byte or aClass == Integer or aClass == Long 
             or aClass == Real or aClass == Double;
      end
      
    proc castOk( value : double ) : boolean
      begin
      java$use "import java.lang.Math;"
      java$begin
      if ( Math.abs(_value) < 1e-10 )
         return false;
      else
         return true;
      java$end
      end      
                                                              
      
      /* each of the following methods is based on a similar constant
         found in the header file "limits.h" of the standard C
         library. The method description is a  copy of the
         description of the corresponding constant as found in K&R. The
         method bodies are dependent on the platform and therefore not
         defined. */
        
    proc getRadix() : integer
       // radix of exponent representation 
       begin
       return 0;
       end
       
    proc getRounds() : integer
       // mode for addition
       begin
       return 0;
       end
       
    proc getPrecision() : integer
       // decimal digits of precision
       begin
       return 0;
       end
       
    proc getEpsilon() : real
       // smaller number e such that 1.0 + e <> 1.0
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
    proc getMantDig() : integer
       // number of base ``getRadix()'' in mantissa
       begin
       java$begin
       return 0;
       java$end
       end
       
    proc getMinValue() : real
       // minimum real number
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
    proc getMaxValue() : real
       // maximum real number
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
    proc getMaxExp() : real 
       // greater k such that k^n is representable
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       
    proc getMinExp() : real
       // smaller k such that k^n is a normalized number
       begin
       java$begin
       return (float ) 0.0;
       java$end
       end
       

end


class real subclassOf AnyValue
  public:
  
    proc getInfo() : AnyObjectInfo
       begin
       return nil;
       end
    
       
    proc toString() : String
       begin
       java$begin
       return (new Float(_self)).toString();
       java$end
       end
    proc equals( other : real ) : boolean
      /* returns true if self is equal to other. A warning should be
         issued if this method is used */
       begin
       java$begin
       return _self == _other;
       java$end
       end
    
      /* these operators can only be used with variables. Unlike C++, they
         don't return anything. */
    proc ++()
    proc --()
    
      // unary 
    proc +  () : real    
    proc -  () : real    
      // binary 
    proc +  ( other : real ) : real    
    proc -  ( other : real ) : real    
    proc *  ( other : real ) : real    
    proc /  ( other : real ) : real    
    
      /* comparison. A warning should be issued whenever == or <> is used. */
    proc == ( other : real ) : boolean    
    proc <> ( other : real ) : boolean    
    proc <  ( other : real ) : boolean    
    proc <= ( other : real ) : boolean    
    proc >  ( other : real ) : boolean    
    proc >= ( other : real ) : boolean    
    
  //private:
  //  var value : lowLevelReal;
end


