object Runtime

     proc init()
       begin
       endList = List(Action).new();
       catchObjectStack = Vector(Catch).new();
       end
       
   public:
   
      proc exit( errorCode : integer )
         begin
         java$begin
         System.exit(_errorCode);
         java$end
         end
         
      proc putAtEndList( f : Action )
         begin
         endList.add(f);
         end
         
      proc getClasses() : array(ClassInfo)[]
         begin
         return arrayCI;
         end
         
      proc $setClasses( arrayCI : array(ClassInfo)[] )
         begin
         self.arrayCI = arrayCI;
         end
         
      proc searchForClass( name : String ) : ClassInfo
            var i : integer;
         begin
         for i = 0 to arrayCI.getSize() - 1 do
            if arrayCI[i].getName().compareTo(name) == 0 
            then
               return arrayCI[i];
            endif
         return nil;
         end
         
      proc getMethodCallStack() 
              ( exception : CatchNoReflectiveCallInfoException )
              : Stack(MethodCallInfo)
         begin
         if methodCallStack == nil
         then
            exception.throw( NoReflectiveCallInfoException.new() );
         endif
         return methodCallStack;
         end
         
      proc $addMethodCallStack( methodCall : MethodCallInfo )
         begin
         methodCallStack.add(methodCall);
         end

      proc $removeMethodCallStack()
         begin
         methodCallStack.remove();
         end
         
      proc getCatchObjectStack() : Stack(Catch)
         begin
         return catchObjectStack;
         end

      proc $addCatchObjectStack( catch : Catch ) 
         begin
         catchObjectStack.add(catch);
         end
         
      proc $removeCatchObjectStack() 
         begin
         catchObjectStack.remove();
         end
         
      proc getMethodThrownException()
              ( exception : CatchNoExceptionInfoException ) : MethodInfo
         begin
         return methodThrownException;
         end
         
      proc $setMethodThrownException( methodThrownException : MethodInfo )
         begin
         self.methodThrownException = methodThrownException;
         end
         
      proc getNameMethodThrownException()
              ( exception : CatchNoExceptionInfoException ) : String
         begin
         return nameMethodThrownException;
         end
         
      proc $setNameMethodThrownException( nameMethodThrownException : String )
         begin
         self.nameMethodThrownException = nameMethodThrownException;
         end
         
         
         
      proc getClassThrownException()
              ( exception : CatchNoExceptionInfoException ) : ClassInfo
         begin
         return classThrownException;
         end
         
      proc $setClassThrownException( classThrownException : ClassInfo )
         begin
         self.classThrownException = classThrownException;
         end
         
      proc setCatchUnchecked( myCatch : CatchUncheckedException )
         begin
         catchObjectStack.add(myCatch, 0);
         end
         
      proc getCatchUnchecked() : Catch
         begin
         return catchObjectStack.get(0);
         end

   private:
      var 
         endList : List(Action);
         methodThrownException : MethodInfo;
         nameMethodThrownException : String;
         catchObjectStack : Vector(Catch);
         methodCallStack : Stack(MethodCallInfo);
         classThrownException : ClassInfo;
         arrayCI : array(ClassInfo)[];
end      
      