class ClassMethodInfo subclassOf MethodInfo

   proc init( 
         name : String;
         isMethodAbstract : boolean;
         methodNumber : integer;
         methodBodyInfo : MethodBodyInfo;
         visibility : integer;
         arrayPT : array(ClassInfo)[];
         returnType : ClassInfo;
         arrayPI : array(ParameterInfo)[];
         exceptionI : ClassInfo;
         codeAnnotation : array(CodeAnnotation)[]
         )
      begin
      super.init( name, methodBodyInfo, visibility, arrayPT, returnType, arrayPI, 
         exceptionI, codeAnnotation );
      self.isMethodAbstract = isMethodAbstract;
      self.methodNumber = methodNumber;
      end
      
   public:
   
      proc isAbstract() : boolean
         begin
         return isMethodAbstract;
         end

      proc getMethodNumber() : integer
         begin
         return methodNumber;
         end
         
      proc invoke( obj : Any; args : array(Any)[] )
                 ( exception : CatchInvokePackedException ) : Any
         begin
         if obj.getInfo().getMethod( getName(), getParameterTypes() ) == nil
         then
            exception.throw( TypeErrorException.new() );
         endif
         java$begin
         return _obj.$callMethod(_methodNumber, _args);
         java$end
         end
         
      //c
      /*proc invoke_v( obj : Any; args : ... array(Any)[] )
                   (exception : CatchInvokePackedException ) : Any   
         begin
         if obj.getInfo().getMethod( getName(), getParameterTypes() ) == nil
         then
            exception.throw( TypeErrorException.new() );
         endif
         java$begin
         return _obj.$callMethod(_methodNumber, _args);
         java$end
         end
      */
          
   private:
      var isMethodAbstract : boolean;
          methodNumber : integer;
          
end

      