class ClassObjectInfo subclassOf AnyObjectInfo

   proc init( 
         obj : Any;
         initMethodInfo : ObjectInitMethodInfo;
         arrayCI  : array(ConstantInfo)[];
         arrayIVI : array(ObjectInstanceVariableInfo)[];
         arrayMI  : array(ObjectMethodInfo)[];
         arrayNMI  : array(ObjectMethodInfo)[];
         typeI    : ClassInfo;
         codeAnnotation : array(CodeAnnotation)[]
         )
         
        var i : integer;
      begin
      super.init(arrayIVI, arrayMI, typeI);
      self.obj = obj;
      self.initMethodInfo = initMethodInfo;
      self.arrayCI = arrayCI;
      self.arrayNMI = arrayNMI;
      self.codeAnnotation = codeAnnotation;
      for i = 0 to arrayMI.getSize() - 1 do
         arrayMI[i].setObject(obj);
      for i = 0 to arrayIVI.getSize() - 1 do
         arrayIVI[i].setObject(obj);
      end
      
   public:

   
      proc getObject() : Any
         begin
         return obj;
         end
         
   
      proc new( args : array(Any)[] )
              (exception : CatchNewException ) : Any
            var i : integer;
         begin
         /*
         //c
         for i = 0 to arrayNMI.getSize() - 1 do
            if arrayNMI[i].matchInterface(args)
            then
               java$begin
               return _obj.$callMethod( _arrayNMI[_i]._getMethodNumber(), _args);
               java$end
            endif
         */
         exception.throw( WrongParametersException.new() );
         end
              
        
      //c
      /*proc new_v( args : ... array(Any)[] )
                (exception : CatchNewException ) : Any 
         begin
         for i : integer = 0 to arrayNMI.getSize() - 1 do
            if arrayNMI[i].matchInterface(args)
            then
               java$begin
               return _obj.$callMethod( _arrayNMI[_i]._getMethodNumber(), _args);
               java$end
            endif
         exception.throw( WrongParametersException.new() );
         end
      */
              
      proc getInitMethod() : ObjectInitMethodInfo
         begin
         return initMethodInfo;
         end
         
      proc getPublicConstants() : array(ConstantInfo)[]
            var
               v : Vector(ConstantInfo);
         begin
         v#init();
         for i : integer = 0 to arrayCI.getSize() - 1 do
            if arrayCI[i].getVisibility() == MethodInfo.public_v
            then
               v.add(arrayCI[i]);
            endif
         return v.toArray();
         end
         
      proc getConstants() : array(ConstantInfo)[]
         begin
         return arrayCI;
         end


      proc getNotes() : array(CodeAnnotation)[]
         begin
         return codeAnnotation;
         end
      
         
   private:
      var 
          obj : Any;
          initMethodInfo : ObjectInitMethodInfo;
          arrayCI : array(ConstantInfo)[];
          arrayEI : array(EnumInfo)[];
          arrayNMI  : array(ObjectMethodInfo)[];
          codeAnnotation : array(CodeAnnotation)[];

end      