object MethodInfo

   public:
      enum ( constructor_v, public_v, private_v, subclass_v );
      
end

class MethodInfo

    proc init( 
         name : String;
         methodBodyInfo : MethodBodyInfo;
         visibility : integer;
         arrayPT : array(ClassInfo)[];
         returnType : ClassInfo;
         arrayPI : array(ParameterInfo)[];
         exceptionI : ClassInfo;
         codeAnnotation : array(CodeAnnotation)[]
         )
      begin
      self.name = name;
      self.methodBodyInfo = methodBodyInfo;
      self.visibility = visibility;
      self.arrayPT = arrayPT;
      self.returnType = returnType;
      self.arrayPI = arrayPI;
      self.exceptionI = exceptionI;
      self.codeAnnotation = codeAnnotation;
      end
      
   public:
   
      proc getName() : String
         begin
         return name;
         end
         
      proc toString() : String
            var s : String;
         begin
         s = name + "(";
         var size : integer = arrayPT.getSize();
         for i : integer = 0 to arrayPT.getSize() - 1 do
            begin
            s = s + arrayPT[i].getName();
            --size;
            if size > 0
            then
               s = s + ", ";
            endif
            end
         return s;
         end
         
      proc getBodyInfo() : MethodBodyInfo
         begin
         return methodBodyInfo;
         end
         
      proc getVisibility() : integer
         begin
         return visibility;
         end
         
      proc getParameterTypes() : array(ClassInfo)[]
         begin
         return arrayPT;
         end
         
         
      proc getReturnType() : ClassInfo
         begin
         return returnType;
         end
         
         
      proc getParameters() : array(ParameterInfo)[]
         begin
         return arrayPI;
         end
         
      proc getExceptionClass() : ClassInfo
         begin
         return exceptionI;
         end
         
      proc getNotes() : array(CodeAnnotation)[]
         begin
         return codeAnnotation;
         end
      
      proc matchInterface( name : String; paramTypes : array(ClassInfo)[] ) : boolean
         begin
         if  name.compareTo(self.name) <> 0 or 
             paramTypes.getSize() <> arrayPT.getSize()
         then
            return false;
         else
            for i : integer = 0 to arrayPT.getSize() - 1 do
               if arrayPT[i].getName().compareTo(paramTypes[i].getName()) <> 0
               then
                  return false;
               endif
            return true;
         endif
         end
      
      //c
      /*proc matchInterface( name : String; paramTypes : array(AnyClassObject)[] ) : boolean
         begin
         if  name.compareTo(self.name) <> 0 or 
             paramTypes.getSize() <> arrayPT.getSize()
         then
            return false;
         else
            for i : integer = 0 to arrayPT.getSize() - 1 do
               if arrayPT[i].getName().compareTo(paramTypes[i].getName()) <> 0
               then
                  return false;
               endif
            return true;
         endif
         end
      */
      
      proc matchInterface( other : MethodInfo ) : boolean
            var otherPT : array(ClassInfo)[];
         begin
         otherPT = other.getParameterTypes();
         if other.getName().compareTo(name) <> 0 or otherPT.getSize() <> arrayPT.getSize()
         then
            return false;
         else
            for i : integer = 0 to arrayPT.getSize() - 1 do
               if arrayPT[i].getName().compareTo(otherPT[i].getName()) == 0
               then
                  return false;
               endif
            return true;
         endif
         end
         
   private:
   
      var 
        name : String;
        methodBodyInfo : MethodBodyInfo;
        visibility : integer;
        arrayPT : array(ClassInfo)[];
        returnType : ClassInfo;
        arrayPI : array(ParameterInfo)[];
        exceptionI : ClassInfo;
        codeAnnotation : array(CodeAnnotation)[];

end            
