package Interface;

import java.util.*;
import java.io.*;
import CompilerError.*;

public class MethodInterfaceList {

    public MethodInterfaceList() {
       h = new Hashtable();
       v = new Vector();
    }

    public void add(MethodInterface aMethod) {
       h.put( aMethod.getSearchName(), aMethod );
       v.addElement(aMethod);
    }
    

    public Enumeration elements() {
       return h.keys();
    }

    public Enumeration anyElements() {
       return v.elements();
    }
    
    
    public MethodInterface get( String searchName ) {
        return (MethodInterface ) h.get(searchName);
    }


   public Hashtable multipleGet( String anySearchMethodaName ) {
       return multipleGet(anySearchMethodaName, new Hashtable());
   }
    
   public Hashtable multipleGet( String anySearchMethodName, Hashtable result ) {
      Enumeration e = v.elements();
      MethodInterface mi;
      while ( e.hasMoreElements() ) {
         mi = (MethodInterface ) e.nextElement();
         if ( mi.getAnySearchName().compareTo(anySearchMethodName) == 0 ) 
            // if there is already a method with the same name and parameters, don't insert
            if ( result.get(mi.getSearchName()) == null ) 
               result.put(mi.getSearchName(), mi);
      }
      return result;
   }
            
   public void genI( PrintWriter out ) {
      sort();
      MethodInterface m;
      Enumeration e = v.elements();
      while ( e.hasMoreElements() ) {
         m = (MethodInterface ) e.nextElement();
         m.genI(out);
      }
   }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
      MethodInterface m;
      Enumeration e = h.keys();
      while ( e.hasMoreElements() ) {
         m = (MethodInterface ) h.get(e.nextElement());
         m.reify(til, em);
      }
   }
     
   public int getSize() {
      return h.size();
   }

   public void genNewMethods( PrintWriter out, String className ) {
      Enumeration e = h.keys();
      while ( e.hasMoreElements() )
         ((MethodInterface ) h.get(e.nextElement())).genNewMethod(out, className);
   }
   
   
   public void sort() {
      int k;
      MethodInterface m;
      int size = v.size();
      if ( size > 1 ) {
         for (int i = 0; i < size; i++) {
            m = (MethodInterface ) v.elementAt(i);
            String smaller = m.getSearchName();
            k = i;
            for (int j = i + 1; j < size; j++)
               if ( ((MethodInterface ) v.elementAt(j)).getSearchName().compareTo(smaller) < 0 ) {
                  m = (MethodInterface ) v.elementAt(j);
                  smaller = m.getSearchName();
                  k = j;
               }
            if ( k != i ){
               MethodInterface aux = (MethodInterface ) v.elementAt(i);
               v.setElementAt( m, i );
               v.setElementAt( aux, k );
            }
                  
         }
      }
   }
  
   

    private Hashtable h;
    private Vector v;

}
