import java.io.*;

public class MyFile {
    
    public MyFile( String filename ) {
        this.filename = filename;
    }
    
    public String getName() {
        return filename;
    }
    
    private String filename;
    public static final int 
       ok_e = 0, 
       do_not_exist_e = 1, 
       cannot_be_read_e = 2,
       read_error_e = 3,
       write_error_e = 4,
       close_error_e = 5;
       
    private int error;
    
    public int getError() {
        return error;
    }

    public char []readFile() {
        FileReader stream;
        int numChRead;
        
        error = ok_e;
        
        File file = new File(filename);
        if ( ! file.exists() ) {
           error = do_not_exist_e;
           return null;
        }
        else if ( ! file.canRead() ) {
           error = cannot_be_read_e;
           return null;
         }
         
         try { 
             stream = new FileReader(file);  
         } catch ( FileNotFoundException e ) {
            error = do_not_exist_e;
            return null;
         }
                // one more character for '\0' at the end that will be added by the
                // compiler
         char []input = new char[ (int ) file.length() + 1 ];
            
         try {
            numChRead = stream.read( input, 0, (int ) file.length() );
         } catch ( IOException e ) {
            error = cannot_be_read_e;
            return null;
         }
                
         if ( numChRead != file.length() ) {
            error = read_error_e;
            return null;
         }
         try {
            stream.close();
         } catch ( IOException e ) {
            error = close_error_e;
            return null;
         }
         return input;
    }

}