
import java.io.*;


public class ProjectError {
    
  public ProjectError( PrintWriter out ) {
    this.out = out;
    wasACompilerError = false;
  }
 
  public void show(String msg, int lineNumber ) {
    
     if ( lineNumber == -1 )
        out.println( msg );
     else
        out.println("At line(" + lineNumber + ")" + msg );
     wasACompilerError = true;
     out.flush();
     throw new ProjectException();
  }

  public void show( String msg ) {
    show(msg, -1);
  }
  
  public void signal(String msg, int lineNumber ) {
     show(msg, lineNumber);
     throw new ProjectException();
  }
  
  public boolean getWasACompilerError() {
    return wasACompilerError;
  }
  
  private PrintWriter out;
  private boolean wasACompilerError;
}

    