package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;
import MySym;

public class ArithmeticUnaryExpr extends UnaryExpr {

    public ArithmeticUnaryExpr( int oper, Expr right ) {
       super(oper, right);
    }

    public void gen( PrintWriter out, Context context ) {
       switch (oper) {
           case MySym.PLUS :
              out.print("+");
              break;
           case MySym.MINUS :
              out.print("-");
              break;
           case MySym.PLUSPLUS :
              out.print("++");
              break;
           case MySym.MINUSMINUS :
              out.print("--");
              break;
           default :
              ErrorMsg.signalFatalError("Unknown operator in ArithmeticUnaryExpr");
       }
       right.gen(out, context);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
