package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class ArrayIndexing extends Expr {

    public ArrayIndexing(Expr array, Expr index) {
       this.array = array;
       this.index = index;
    }

    public Type getType() {
        ArrayType at = (ArrayType ) array.getType();
        return at.getType();
    }

    public void gen( PrintWriter out, Context context ) {
       array.gen(out, context);
       out.print(".v[");
       index.gen(out, context, false);
       out.print("]");
    }

    public boolean getIsLeftValue() {
         return array.getIsLeftValue();
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr array;
    private Expr index;

}
