package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class ArrayInitExprList extends Expr {

    public ArrayInitExprList(Expr left, ConstExprList exprList) {
       this.left = left;
       this.exprList = exprList;
    }

    public Type getType() {
        return exprList.getType();
    }

    public void gen( PrintWriter out, Context context ) {
       out.print("{ ");
       exprList.gen(out, context);
       out.print(" }");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr left;
    private ConstExprList exprList;

}
