package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class AssertVariableList {

    public AssertVariableList() {
        varList = new Vector();
    }

    public void add(AssertVariable assertVariable) {
       varList.addElement(assertVariable);
    }

    public Enumeration elements() {
        return varList.elements();
    }

    public void gen( PrintWriter out, Context context ) {
       ws.add();
       Enumeration e = varList.elements();
       while ( e.hasMoreElements() ) {
           AssertVariable v = (AssertVariable ) e.nextElement();
           ws.print( v.getType().getJavaName() );
           out.print(" " + v.getJavaName() + " = ");
           v.getValue().gen(out, context);
           out.println(";");
       }
       ws.sub();
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Vector varList;

}
