package AST;

import java.lang.*;
import ws;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;
import NameServer;

abstract public class BasicType extends Type {

    public BasicType(String name) {
       super();
       setName(name);
    }

    abstract public Type getWrapperType();

    public boolean isSupertypeOf(Type other) {
        return this == other;
    }

    public String getJavaWrapperName() {
        throw new RuntimeException("Internal error in getJavaWrapperName");
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
    }

    public boolean hasArray() {
        return true;
    }

    abstract public String getWrapperName();

    public String getNewWrapperString() {
        if ( newWrapperString == null ) {
           Parameter p = new Parameter("p");
           p.setType(this);
           ParameterList pl = new ParameterList();
           pl.add(p);
           newWrapperString = getJavaWrapperName() + ".$classObject." + 
                       NameServer.getMethodJavaName( "new", pl ) + "(";
        }
        return newWrapperString;
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private String newWrapperString;

}
