package AST;

import java.lang.*;
import ws;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;
import MySym;

public class BinCompositeExpr extends CompositeExpr {

    public BinCompositeExpr( Expr left, int oper, Expr right ) {
       super(left, oper, right);
    }

    public Type getType() {
        return left.getType();
    }

    public String getStringOper() {
       switch ( oper ) {
           case MySym.BINAND:
             return " & ";
           case MySym.BINOR:
             return " | ";
           case MySym.BINXOR:
             return " ^ ";
           default :
              ErrorMsg.signalFatalError("Unknown operator in BinCompositeExpr");
              return "";
       }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
