package AST;

import java.lang.*;
import ws;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class BooleanType extends BasicType {

    public BooleanType() {
       super("boolean");
       //setSuperclass( new ClassType("AnyValue", null, false) );
    }

    public Type getWrapperType() {
         return Type.wrapperBooleanType;
    }

    public String getJavaZeroValue() {
         return "false";
    }

    public String genToWrapper(String expr) {
       return "Boolean.new(" + expr + ")" ;
    }

    public String genFromWrapper(String expr) {
       return "((Boolean) " + expr + ").booleanValue()";
    }

    public String getJavaWrapperName() {
        return "_Boolean";
    }

    public String getWrapperName() {
        return "Boolean";
    }

    public String getJavaName() {
        return "boolean";
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
