package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class ClassObjectExpr extends Expr {

    public ClassObjectExpr(ClassObjectType classObjectType) {
       this.classObjectType = classObjectType;
    }

    public Type getType() {
        return classObjectType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print( classObjectType.getAccessToClassObject() );
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public ClassObjectType getClassObjectType() {
       return classObjectType;
    }

    private ClassObjectType classObjectType;

}
