package AST;

import java.lang.*;
import ws;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class ClassType extends Type {

    public ClassType( String name, TypeList typeList ) {
       super(name);
       this.typeList = typeList;
       setIsClassObjectType(true);
       setRealJavaName();
    }

    public String getGreenName() {
        if ( typeList == null ) 
           return getName();
        else {
           String s = getName() + "(";
           int size = typeList.getSize();
           Enumeration e = typeList.elements();
           while ( e.hasMoreElements() ) {
              String paramName = ((Type ) e.nextElement()).getGreenName();
              s = s + paramName;
              if ( --size > 0 )
                 s = s + ", ";
           }
           s = s + ")";
           return s;
        }
    }

    public String getInterfaceName() {
        if ( typeList == null ) 
           return getName();
        else 
           return javaName;
    }

    public void setRealJavaName() {
       if ( typeList == null ) 
          super.setJavaName();
       else 
          javaName = TypeInterface.buildClassName(getName(), typeList);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public TypeList getTypeList() {
       return typeList;
    }

    public GenericClass getReifiedClass() {
       return reifiedClass;
    }

    private TypeList typeList;
    private GenericClass reifiedClass;

}
