package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

abstract public class CompositeExpr extends Expr {

    public CompositeExpr( Expr left, int oper, Expr right ) {
        this.left = left;
        this.oper = oper;
        this.right = right;
    }

    abstract public String getStringOper();

    public void gen( PrintWriter out, Context context ) {
       gen(out, context, true);
    }

    public void gen( PrintWriter out, Context context, boolean useParenthesis ) {
       if ( useParenthesis )
          out.print("(");
       left.gen(out, context);
       out.print( getStringOper() );
       right.gen(out, context);
       if ( useParenthesis )
          out.print(")");
    }

    protected Expr left;
    protected Expr right;
    protected int oper;

}
