package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;
import NameServer;

public class Constant extends Identifier {

    public Object getValue() {
        return value.getValue();
    }

    public Constant( String name, Type type, Expr value, int visibility ) {
       super(name);
       this.type = type;
       this.value = value;
       this.visibility = visibility;
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
    }

    public void gen( PrintWriter out, Context context ) {
        out.print("static final " + type.getJavaName() + " " 
              + getJavaName() + " = ");
        value.gen(out, context);
        out.println(";");
    }

    public void genI(PrintWriter out) {
        WhiteSpace.printMember(out);
        out.print("const " + getName() + " : " + type.getName() + " = ");
        ((LiteralConstExpr ) value).genI(out);
        out.println(";");
    }

    public void genConstantInfo(PrintWriter out) {
         //changed
         BasicType t = (BasicType ) type;
         
         Parameter p = new Parameter("p");
         p.setType(value.getType());
         ParameterList pl = new ParameterList();
         pl.add(p);
         ws.print( "(_ConstantInfo ) _ConstantInfo.$classObject._new$String$_ClassInfo$int$_Any$$Array$1$_CodeAnnotation( \"" + getName() + "\", " + 
                   ((ClassTypeInterface ) type.getTypeInterface()).
                    getClassObjectInterface().getAccessToClassInfo() + ", " +
                    
                    Method.getStringAccessVisibility(visibility) + ", " +
                    t.getJavaWrapperName() + ".$classObject." + 
                       NameServer.getMethodJavaName( "new", pl ) + "(" + 
                    ((LiteralConstExpr ) value).getStringValue() + "), null )" );
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Type getType() {
       return type;
    }

    private Type type;
    private Expr value;
    private int visibility;

}
