package AST;

import java.lang.*;
import ws;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class DoubleType extends BasicType {

    public DoubleType() {
       super("double");
       //setSuperclass( new ClassType("AnyValue", null, false) );
    }

    public Type getWrapperType() {
         return Type.wrapperDoubleType;
    }

    public String getJavaZeroValue() {
         return "0.0";
    }

    public String genToWrapper(String expr) {
       return "Double.new(" + expr + ")";
    }

    public String genFromWrapper(String expr) {
       return "((Double ) " + expr + ").doubleValue()";
    }

    public String getJavaWrapperName() {
        return "_Double";
    }

    public String getJavaName() {
        return "double";
    }

    public String getWrapperName() {
        return "Double";
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
