package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;
import NameServer;

public class InitCallStatement extends Expr {

    public InitCallStatement(MethodInterface methodInterface, Variable variable, ExprList exprList) {
       this.methodInterface = methodInterface;
       this.variable = variable;
       this.exprList = exprList;
    }

    public Type getType() {
        return Type.voidType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print(variable.getJavaName() + " = ");
       ParameterList pl = new ParameterList();
       int i = 0;
       Enumeration e = exprList.elements();
       while ( e.hasMoreElements() ) {
          Parameter p = new Parameter("p" + i);
          p.setType( ((Expr ) e.nextElement()).getType() );
          pl.add(p);
       }
       out.print( variable.getType().getJavaName() + ".$classObject." 
          + NameServer.getMethodJavaName( "new", pl ) + "(");
       exprList.gen(out, context);
       out.print(")");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private MethodInterface methodInterface;
    private Variable variable;
    private ExprList exprList;

}
