package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class InitMethodList {

    public InitMethodList() {
       initMethodList = new Vector();
    }

    public void add(InitMethod initMethod) {
       initMethodList.addElement( initMethod );
    }

    public InitMethod search(ExprList exprList) {
        String searchName = "init$" + exprList.getSize();
        Enumeration e = exprList.elements();
        while ( e.hasMoreElements() ) 
           searchName = searchName + "$" + 
               ((Expr ) e.nextElement()).getType().getJavaName();
        InitMethod im = (InitMethod ) initTable.get(searchName);
        if ( im == null ) 
           return null;
        else {
             //c  must check if the real parameters are subtypes
           Enumeration f = im.getTypeList().elements();
           e = exprList.elements();
           while ( e.hasMoreElements() ) 
               if (  ((Type ) f.nextElement()) != ((Type ) e.nextElement())  )
                  return null;
           return im;
        }
    }

    public Enumeration elements() {
       return initMethodList.elements();
    }

    public int getSize() {
        return initMethodList.size();
    }

    public void gen( PrintWriter out, boolean isBasicType, Context context ) {
        sort();
        out.println();
        Enumeration e = initMethodList.elements();
        while ( e.hasMoreElements() ) 
           ((InitMethod) e.nextElement()).gen(out, isBasicType, context);
    }

    public void sort() {
         int k;
         Method m;
         int size = initMethodList.size();
         if ( size > 1 ) {
            for (int i = 0; i < size; i++) {
               m = (Method ) initMethodList.elementAt(i);
               String smaller = m.getSearchName();
               k = i;
               for (int j = i + 1; j < size; j++)
                  if ( ((Method ) initMethodList.elementAt(j)).getSearchName().compareTo(smaller) < 0 ) {
                     m = (Method ) initMethodList.elementAt(j);
                     smaller = m.getSearchName();
                     k = j;
                  }
               if ( k != i ){
                  Method aux = (Method ) initMethodList.elementAt(i);
                  initMethodList.setElementAt( m, i );
                  initMethodList.setElementAt( aux, k );
               }
                     
            }
         }
    }

    public void genCaseCallMethod(PrintWriter out) {
         Enumeration e = initMethodList.elements();
         while ( e.hasMoreElements() ) 
            ((InitMethod ) e.nextElement()).genCaseCallMethod(out);
    }

    public void genClassMethodInfoVarList( PrintWriter out, boolean putComma ) {
         int size = initMethodList.size();
         Enumeration e = initMethodList.elements();
         while ( e.hasMoreElements() ) {
            ws.print( ((Method) e.nextElement()).getClassMethodInfoNameVar() );
            if ( --size > 0 )
               out.println(",");
         }
         if ( putComma )
            out.println(",");
         else if ( initMethodList.size() > 0 )
            out.println();
    }

    public void genClassMethodInfo(PrintWriter out) {
         Enumeration e = initMethodList.elements();
         while ( e.hasMoreElements() ) {
            ((InitMethod ) e.nextElement()).genClassMethodInfo(out);
         }
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Vector initMethodList;
    private Hashtable initTable;

}
