package AST;

import java.lang.*;
import ws;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class IntegerType extends BasicType {

    public IntegerType() {
       super("integer");
       //setSuperclass( new ClassType("AnyValue", null, false) );
    }

    public Type getWrapperType() {
         return Type.wrapperIntegerType;
    }

    public String getJavaZeroValue() {
         return "0";
    }

    public String genToWrapper(String expr) {
       return "Integer.new(" + expr + ")";
    }

    public String genFromWrapper(String expr) {
       return "((Integer ) " + expr + ").intValue()";
    }

    public String getJavaWrapperName() {
        return "_Integer";
    }

    public String getJavaName() {
        return "int";
    }

    public String getWrapperName() {
        return "Integer";
    }

    static final int sizeInBytes = 4;

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
