package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class LiteralBooleanConst extends LiteralConstExpr {

    public LiteralBooleanConst(boolean value) {
       this.value = value;
    }

    public Object getValue() {
        return new Boolean(value);
    }

    public String getStringValue() {
        return (new Boolean(value)).toString();
    }

    public Type getType() {
        return Type.booleanType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print(value);
    }

    public void genI(PrintWriter out) {
       out.print(value);
    }

    public static LiteralBooleanConst booleanTrue  = new LiteralBooleanConst(true);
    public static LiteralBooleanConst booleanFalse = new LiteralBooleanConst(false);

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private boolean value;

}
