package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class LiteralByteConst extends LiteralConstExpr {

    public LiteralByteConst(byte value) {
       this.value = value;
    }

    public Object getValue() {
        return new Byte(value);
    }

    public String getStringValue() {
        return (new Byte(value)).toString();
    }

    public Type getType() {
        return Type.byteType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print(value);
    }

    public void genI(PrintWriter out) {
       out.print(value);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private byte value;

}
