package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class LiteralDoubleConst extends LiteralConstExpr {

    public LiteralDoubleConst(double value) {
       this.value = value;
    }

    public Object getValue() {
        return new Double(value);
    }

    public String getStringValue() {
        return (new Double(value)).toString();
    }

    public Type getType() {
        return Type.doubleType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print(value);
    }

    public void genI(PrintWriter out) {
       out.print(value);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private double value;

}
