package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class LiteralRealConst extends LiteralConstExpr {

    public LiteralRealConst(float value) {
       this.value = value;
    }

    public Object getValue() {
        return new Float(value);
    }

    public String getStringValue() {
        return (new Float(value)).toString();
    }

    public Type getType() {
        return Type.realType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print(value + "F" );
    }

    public void genI(PrintWriter out) {
       out.print(value);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private float value;

}
