package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class LiteralStringExpr extends Expr {

    public LiteralStringExpr(String string) {
       this.string = string;
    }

    public String getStringValue() {
        return string;
    }

    public Object getValue() {
        return string;
    }

    public Type getType() {
        return Type.stringType;
    }

    public void gen( PrintWriter out, Context context ) {
       out.print("\"" + string + "\"");
    }

    public void genI(PrintWriter out) {
       out.print("\"" + string + "\"");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public String getString() {
       return string;
    }

    private String string;

}
