package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;
import GreenProject;

public class Parameter extends LocalVariable {

    public Parameter(String name) {
       super(name);
       isVariableNumber = false;
    }

    public boolean isSelf() {
       return getName().compareTo("self") == 0;
    }

    public void genDeclaration(PrintWriter out) {
        Type t = getType();
        if ( t instanceof BasicType || 
             GreenProject.subtypeEqualSubclass ||
             t.getIsJavaClass() ||
             t.isArrayType()  
             ) 
           out.print( t.getJavaName() );
        else
           out.print( "_Any" );
        out.print(" " + getJavaName());
    }

    public String getParameterInfoVarName() {
        return "$p$" + getName();
    }

    public boolean getIsVariableNumber() {
       return isVariableNumber;
    }

    public void setIsVariableNumber( boolean isVariableNumber ) {
       this.isVariableNumber = isVariableNumber;
    }

    private boolean isVariableNumber;

}
