package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class ParenthesisExpr extends Expr {

    public ParenthesisExpr(Expr expr) {
       this.expr = expr;
    }

    public Type getType() {
       return expr.getType();
    }

    public void gen( PrintWriter out, Context context ) {
       out.print("(");
       expr.gen(out, context);
       out.print(")");
    }

    public boolean getIsLeftValue() {
         return expr.getIsLeftValue();
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr expr;

}
