package AST;

import java.lang.*;
import ws;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class RealType extends BasicType {

    public RealType() {
       super("real");
       //setSuperclass( new ClassType("AnyValue", null, false) );
    }

    public Type getWrapperType() {
         return Type.wrapperRealType;
    }

    public String getJavaZeroValue() {
         return "0.0f";
    }

    public String genToWrapper(String expr) {
       return "Float.new(" + expr + ")";
    }

    public String genFromWrapper(String expr) {
       return "((Float ) " + expr + ").floatValue()";
    }

    public String getJavaWrapperName() {
        return "_Real";
    }

    public String getJavaName() {
        return "float";
    }

    public String getWrapperName() {
        return "Real";
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
