package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;
import MySym;

public class StringCompositeExpr extends CompositeExpr {

    public StringCompositeExpr( Expr left, Expr right ) {
       super(left, MySym.PLUS, right);
    }

    public Type getType() {
       return Type.stringType;
    }

    public String getStringOper() {
        return " + ";
    }

    public void gen( PrintWriter out, Context context, boolean useParenthesis ) {
       super.gen(out, context, false);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }


}
