package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class TryStatement extends Statement {

    public TryStatement(Expr expr, StatementList statementList) {
       this.expr = expr;
       this.statementList = statementList;
    }

    public void gen( PrintWriter out, Context context ) {
       /*
       expr.gen(out, context);
       ws.println("._set$_Exception$_AnyClassObject(");
       */
       ws.println("try {");
       ws.add();
       statementList.gen(out, context);
       ws.sub();
       ws.println("}");
       ws.println("catch( Exception $throwable ) {" );
       ws.add();
       ws.println("throw new RuntimeException($throwable.toString());");
       ws.sub();
       ws.println("}");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr expr;
    private StatementList statementList;

}
