package AST;

import java.lang.*;
import ws;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class TypeOfClass extends TypeOf {

    public TypeOfClass(ClassType classType) {
       this.classType = classType;
    }

    public TypeOfClass( ClassType classType, TypeInterface typeInterface ) {
         this.classType = classType;
         setTypeInterface(typeInterface);
    }

    public String getName() {
         return classType.getName();
    }

    public String getInterfaceName() {
         return getTypeInterface().getName();
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
         classType.reify(til, em);
         setTypeInterface( ((ClassTypeInterface ) classType.getTypeInterface()).getClassObjectInterface() );
    }

    public String getGreenName() {
         return "type(" + classType.getGreenName() + ")";
    }

    public String getJavaName() {
         return classType.getJavaName();
    }

    public boolean isSupertypeOf(Type other) {
         return classType.isSupertypeOf(other);
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public ClassType getClassType() {
       return classType;
    }

    private ClassType classType;

}
