package AST;

import java.lang.*;
import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

abstract public class Variable extends Identifier {

    public Variable(String name) {
       super(name);
    }

    public boolean isSelf() {
       return false;
    }

    public void gen( PrintWriter out, Context context ) {
        out.print( getJavaName() );
    }

    public void reify( TypeInterfaceList til, ErrorMsg em ) {
         ClassTypeInterface cti;
         
         if ( type instanceof TypeOfClass ) {
            ClassType ct = ((TypeOfClass ) type).getClassType();
            if ( (cti = til.get(ct.getInterfaceName())) == null ) 
               em.show("Class " + ct.getInterfaceName() + " was not found");
            else 
               typeI = cti.getClassObjectInterface();
         }
         else 
            if ( (typeI = til.get(type.getInterfaceName())) == null )
               em.show("Class " + type.getInterfaceName() + " was not found");
         type.reify(til, em);
    }

    public Type getType() {
       return type;
    }

    public void setType( Type type ) {
       this.type = type;
    }

    public TypeInterface getTypeI() {
       return typeI;
    }

    private Type type;
    private TypeInterface typeI;

}
