package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class VariableExpr extends Expr {

    public VariableExpr(Variable variable) {
       this.variable = variable;
    }

    public Type getType() {
        return variable.getType();
    }

    public void gen( PrintWriter out, Context context ) {
       variable.gen(out, context);
    }

    public boolean getIsLeftValue() {
         return true;
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    public Variable getVariable() {
       return variable;
    }

    public void setVariable( Variable variable ) {
       this.variable = variable;
    }

    private Variable variable;

}
