package AST;

import ws;
import java.io.*;
import SymbolTable;
import WhiteSpace;
import java.util.*;
import CompilerError.*;
import Interface.*;

public class WhileStatement extends Statement {

    public WhileStatement(Expr expr, Statement statement) {
       this.expr = expr;
       this.statement = statement;
    }

    public void gen( PrintWriter out, Context context ) {
       ws.print("while ( ");
       expr.gen(out, context, false);
       out.println(" ) {");
       ws.add();
       statement.gen(out, context);
       ws.sub();
       ws.println("}");
    }

    public void accept( Visitor v ) {
        v.visit(this);
    }

    private Expr expr;
    private Statement statement;

}
