import java.io.*;
import java.util.*;


public class Creation {
    
    public static void main( String args[] ) {
       if ( args.length < 2 || args[1].lastIndexOf('.') >= 0 ) {
           System.out.println("Usage:");
           System.out.println("     Creation input output");
           System.out.println("Example: ");
           System.out.println("     Creation Parser.java  Symbol");
           System.out.println("Constants will be taken from Parser.java");
           System.out.println("A file Symbol.java will be created with class Symbol declaring the constants found in Parser.java");
       }
       else 
          (new Creation()).createSym(args[0], args[1]);
    }
    
    void createSym( String fileNameParser, String outClass ) {
        String outClass2 = outClass + ".";
        int sizeMoney = outClass2.length();
        char []money = new char[sizeMoney];
        outClass2.getChars(0, sizeMoney, money, 0);
        
        char []in = readFile(fileNameParser);
        Hashtable h = new Hashtable();
        int k = 0;
        int j;
        while ( in[k] != '\0' ) 
            if ( in[k] != money[0] ) 
               k++;
            else {
                k++;
                j = 1;
                while ( j < sizeMoney && in[k] == money[j] ) {
                    k++;
                    j++;
                }
                if ( j < sizeMoney ) {
                    k -= j;
                    k++;
                }
                else
                   if ( Character.isLetter(in[k]) ) {
                      StringBuffer s = new StringBuffer();
                      while ( Character.isLetter(in[k]) ) {
                          s.append(in[k]);
                          k++;
                      }
                      h.put(s.toString(), "");
                   }
            }
        String arrayConst[] = new String[h.size()]; 
        int i = 0;
        Enumeration e = h.keys();
        while ( e.hasMoreElements() ) 
           arrayConst[i++] = (String ) e.nextElement();
        int size = h.size();
        int min;
        for (i = 0; i < size - 1; i++) {
           min = i;
           for (j = i + 1; j < size; j++)
              if ( arrayConst[j].compareTo(arrayConst[min]) < 0 )
                 min = j;
           String aux = arrayConst[min];
           arrayConst[min] = arrayConst[i];
           arrayConst[i] = aux;
        }
        FileOutputStream outStream = null;
        PrintWriter out;
        try {
            outStream = new FileOutputStream(outClass + ".java");
        } catch ( Exception exc ) {
            System.out.println("Can't create " + outClass + ".java");
            return;
        }
        out = new PrintWriter(outStream);
        out.println("public class " + outClass + " {");
        out.println();
        out.println("   public static final int");
        int count = size;
        for (i = 0; i < size; i++) {
           out.print("      " + arrayConst[i] + " = " + i);
           if ( --count > 0 ) 
              out.println(",");
           else
              out.println(";");
        }
        out.println();
        out.println("}");
        if ( out.checkError() ) {
            System.out.println("Error creating Sym.java");
        }
        out.flush();
                        
        try { 
           outStream.close();
        } catch ( Exception exc ) {
            System.out.println("Error closing Sym.java");
        }
    }
    
        
    public static char []readFile( String fileName ) {
        FileReader stream;
        int numChRead;
        
        File file = new File(fileName);
        if ( ! file.exists() || ! file.canRead() ) {
           System.out.println("Either the file " + fileName + " does not exist or it cannot be read");
           return null;
         }
         try { 
             stream = new FileReader(file);  
         } catch ( FileNotFoundException e ) {
            System.out.println("Something wrong: file " + fileName + " does not exist anymore");
            return null;
         }
                // one more character for '\0' at the end that will be added by the
                // compiler
         char []input = new char[ (int ) file.length() + 1 ];
            
         try {
            numChRead = stream.read( input, 0, (int ) file.length() );
         } catch ( IOException e ) {
            System.out.println("Error reading file " + fileName);
            return null;
         }
                
         if ( numChRead != file.length() ) {
            System.out.println("Read error in file " + fileName);
            return null;
         }
         input[numChRead] = '\0';
         try {
            stream.close();
         } catch ( IOException e ) {
            System.out.println("Error in handling the file " + fileName );
            return null;
         }
         return input;
    }

    
}